CREATE OR REPLACE PROCEDURE ARQUIVO_SPED_FOS(
   P_CDIMPOSTO    IN IMPOSTO.CDIMPOSTO%TYPE,
   P_CDEMPRESA    IN EMPRESA.CDEMPRESA%TYPE,
   P_CDINSCESTA   IN EMPRESA.CDINSCESTA%TYPE,
   P_DTINICIAL    IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL      IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_LIVROMAG     IN VARCHAR2,
   P_TIPO         IN NOTAFISCAL.IDSTATUS%TYPE,
   P_FINALIDADE   IN NOTAFISCAL.CDTIPOOPER%TYPE,
   P_INDESCRITU   IN NOTAFISCAL.IDSTATUS%TYPE,
   P_PERFIL       IN VARCHAR2,
   P_ATIVIDADE    IN VARCHAR2,
   P_VERSAO       IN VARCHAR2,
   P_NRSEQARQMAG  IN ARQMAGNETICO.NRSEQARQMAG%TYPE)
AS
   V_CONTGERA     NUMBER;
   V_CONTREGA     NUMBER;
   V_CONTREGC     NUMBER;
   V_CONTREGC_AUX VARCHAR2(50);
   V_CONTREGD     NUMBER;
   V_CONTREGE     NUMBER;
   V_CONTREGH     NUMBER;
   V_CONTREG9     NUMBER;
   V_TOTSPED      NUMBER;
   V_TOTFORPER_S  NUMBER;
   V_TOTFORPER_E  NUMBER;
BEGIN
   V_TOTSPED := 0;
----------------------------------------------------  /* ABERTURA */  -------------------------------------------------
   V_CONTREGA := 0;
   V_CONTREGA := SPED_INICIO_FOS(P_CDIMPOSTO,P_CDEMPRESA,P_CDINSCESTA,P_DTINICIAL,P_DTFINAL,P_LIVROMAG,P_TIPO,P_FINALIDADE,P_INDESCRITU,P_NRSEQARQMAG,P_PERFIL,P_ATIVIDADE, P_VERSAO);
----------------------------------------------------  /* BLOCO C */   ---------------------------------------------
   V_CONTREGC := 0;
   V_CONTREGC_AUX := SPED_BLOCOC_FOS(P_CDIMPOSTO, P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL,P_LIVROMAG, P_NRSEQARQMAG, P_PERFIL, P_VERSAO);
   V_CONTREGC    := TO_NUMBER(SUBSTR(V_CONTREGC_AUX,1,10));
   V_TOTFORPER_S := TO_NUMBER(SUBSTR(V_CONTREGC_AUX,11,20));
   V_TOTFORPER_E := TO_NUMBER(SUBSTR(V_CONTREGC_AUX,21,30));
----------------------------------------------------  /* BLOCO D */   ---------------------------------------------
   V_CONTREGD := 0;
   V_CONTREGD := SPED_BLOCOD_FOS(P_CDIMPOSTO, P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL, P_LIVROMAG, P_NRSEQARQMAG, P_PERFIL, P_VERSAO);
----------------------------------------------------  /* BLOCO E */   ---------------------------------------------
   V_CONTREGE := 0;
   V_CONTREGE := SPED_BLOCOE_FOS(P_CDIMPOSTO, P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL,P_LIVROMAG, P_NRSEQARQMAG, V_TOTFORPER_S, V_TOTFORPER_E);
---------------------------------------------------- /*  BLOCO H  */ -----------------------------------------------
   V_CONTREGH := 0;
   V_CONTREGH := SPED_BLOCOH_FOS(P_CDIMPOSTO, P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL,P_LIVROMAG,P_NRSEQARQMAG);
---------------------------------------------------- /*  BLOCO 1  */ -----------------------------------------------
   V_CONTREGH := 0;
   V_CONTREGH := SPED_BLOCO1_FOS(P_NRSEQARQMAG);
----------------------------------------------------  /*  BLOCO 9  */  --------------------------------------------
   V_CONTREG9 := 0;
   V_CONTREG9 := SPED_BLOCO9_FOS(V_CONTREGC,V_CONTREGD,V_CONTREGE,V_CONTREGH,P_NRSEQARQMAG);
-------------------------------------   /* ENCERRAMENTO TOTAL DO BLOCO */ ---------------------------------------------
   V_CONTGERA := NVL(V_CONTREGA,0) + NVL(V_CONTREGC,0) + NVL(V_CONTREGD,0) + NVL(V_CONTREGE,0) + NVL(V_CONTREGH,0) + NVL(V_CONTREG9,0)+2;
   /* total de linhas do arquivo  somado mais um quando insere na tabela para que seja considerado o ultimo registro 9999 */
   BEGIN
      SELECT COUNT(*)
      INTO V_TOTSPED
      FROM ARQMAGNETICO
      WHERE NRSEQARQMAG = P_NRSEQARQMAG;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_TOTSPED := 0;
   END;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('99'||LPAD(RTRIM(V_CONTREG9), 8, '0'), '|9999'|| '|' ||RTRIM(V_TOTSPED+1)|| '|',  P_NRSEQARQMAG);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_SPED_FOS','5.11.000'); END;
/